// kommune data
// list of kommune objects
var list=kdata.list;

// kommune selection:
var selected="fill:#990000;fill-opacity:1;stroke:none";
var unselected="fill:#999999;fill-opacity:1;stroke:none";
var neighbourOn="fill:#666666;fill-opacity:1;stroke:none";
var target=null;

// the one and only svg-element
var svg=null;
// the msg element where we show data for a kommune
var msgElt;
// all (kommune) svg-paths in the file
var allPaths=null;

// mark the fylke containing the selected kommune
function markFylke(kommune,on){
	var owner=kommune.parentNode;
	var all=owner.getElementsByTagName("path");
	if(on){
		for(var ix=0;ix <all.length;ix++){
			if(all[ix]!=kommune){
				all[ix].setAttribute("style",neighbourOn);
			}
			else
				all[ix].setAttribute("style",selected);
		}
	}
	else{
		for(var ix=0;ix <all.length;ix++){
			all[ix].setAttribute("style",unselected);
		}
	}	
}
 
// when user click a kommune
function kommune_click(evt) {
	if(target){
		//target.setAttribute("style",unselected);
		markFylke(target,false);
	}
	target=evt.target;
	//console.log(target.id);
	//target.setAttribute("style",selected);
	markFylke(target,true);
	var kname=target.getAttribute("label");
	var kid=target.getAttribute("id");
	// show data
	display(kid,kname);
	
	itemHolder.bringToFront("kommuneinfo");
	itemHolder.bringToFront("mapzoom");	
	
	
}
 
// show all about this kommune
function display(kid,kname){
	// find the object with data
	for(var ix=0;ix < list.length;ix++)
		if(list[ix].id==kid){
		
			// use either:
			//var im='<img class="im" src="'+logoLoader+list[ix].logo+'" alt=""/>'
			var im='<img class="im" src="'+kdata.logoLocation+list[ix].logo+'" alt=""/>'

			
			var N='<div class="kname">'+list[ix].name+'</div>';
			var F='<div class="fylke"> in '+list[ix].fylke+' fylke</div>';
			var C='<div class="center"> Adm. center: '+list[ix].center+'</div>';
			var P='<div class="pop"> Population: '+list[ix].pop+'</div>';			
			var A='<div class="areal"> Area: '+list[ix].area+' km<sup>2</sup></div>';
			// admin center present ?
			if(list[ix].name != list[ix].center)
				msgElt.innerHTML=im+N+F+C+P+A; 
			else
				msgElt.innerHTML=im+N+F+P+A;
			return;
		}
	// Found no data, use the name from svg-file, just dump it
	msgElt.innerHTML='<div class="kname">'+kname+'</div>';
}	

// zooming
function zoom(v){
	// the wrapper
	var mapwrapper=document.getElementById("mapWrapper");
	// the one and only svg-tag
	var svgtag=document.getElementById("NO");
	var w=parseInt(svgtag.getAttribute("width"));
	var h=parseInt(svgtag.getAttribute("height"));
	
	w=Math.min(Math.max(100,w+v),2000);
	h=Math.min(Math.max(100,h+v),2000);
	
	w=''+w+'px';
	h=''+h+'px';
	svgtag.setAttribute("width",w);
	svgtag.setAttribute("height",h);
	
	itemHolder.bringToFront("kommuneinfo");
	itemHolder.bringToFront("mapzoom");
	//mapwrapper.style.left="0px";
	//mapwrapper.style.top="0px";
}


// walk the svg-document and plant click function
function setUp(){
	allPaths=document.getElementsByTagName("path");
	for(ix=0;ix < allPaths.length;ix++){
		allPaths[ix].setAttribute("onclick","kommune_click(evt)");

	}	
	//.. and locate msg box
	msgElt=document.getElementById("kommuneinfo");
}

