//--------------------------------------------------
// JS-object for handling movable and expandable items, itemBoxes
// keep a list of boxes
// help identify boxes from element or id
// initiate  save / restore
// helpers to set/get position for an element
// bs 20150111
//---------------------------------------------------

var itemHolder = {
	// dragging
	initialMouseX: undefined,
	initialMouseY: undefined,
	startX: undefined,
	startY: undefined,
	draggedObject: undefined,
	draggedBox:undefined,
	// who is on top
	MAX_Z_INDEX:1,
	// all boxes
	boxes:[],
	
//----------------------------------------------------
// set up everything
// identifies boxes by claas name "itemBox"
// mark those prepared  with class item "readybox"
	initElements: function(){		
		// complication due to boxes within boxes. To make access normal
		// do only one untouched (not readybox) box on each loop
		var more=true;
		var oneDone=false;
		while (more){
			more=false;
			oneDone=false;
			//var boxList=document.querySelectorAll(".itembox");
			var boxList=document.getElementsByClassName("itembox");
			for(var ix =0;ix<boxList.length;ix++){		
				if(boxList[ix].classList.contains("readybox"))
					continue;
				var b=new itemBox();
				b.setUp(boxList[ix],ix);
				itemHolder.boxes.push(b);
				oneDone=true;
				break;				
			}
			more=oneDone;
		}

		//-------------------------
		// do pop-setup if popManager is availale
		if(typeof popManager !== 'undefined'){
			popManager.setUpPop();
		}
		else{
			//console.log("popManager is undefined");
		}
		//-------------------------
		// pick up things from localstorage
		itemHolder.restoreElements();
		// prepare to save changes
		window.addEventListener('beforeunload',itemHolder.saveElements,false);
	},

	// remove a boxitem from boxes 
	removeElementById:function(boxid){
		for(var ix=0;ix < itemHolder.boxes.length;ix++){
			if(itemHolder.boxes[ix].getId()==boxid){
				itemHolder.boxes.splice(ix,1);
				return;
			}
		}
	},
	
	// reestablish original box
	removeAndRebuild:function(boxId){
		itemHolder.removeElementById(boxId);
		itemHolder.initElements();
	},
	
//-------------------------------------	
// access to z-index
	getMaxZIndex:function(){
		return itemHolder.MAX_Z_INDEX;
	},
	setMaxZIndex:function(z){
		itemHolder.MAX_Z_INDEX=z;
	},
	incrementMaxZIndex:function(){
		itemHolder.MAX_Z_INDEX=itemHolder.MAX_Z_INDEX+1;
	},
	// bring a box in front,	parameter is id
	bringToFront:function(id){
		var box=itemHolder.getBoxById(id);
		if(box){
			itemHolder.incrementMaxZIndex();
			box.setZIndex(itemHolder.MAX_Z_INDEX);
		}
	},


// ------------------------------------
// persistance	
// remember as localstorage
	saveElements:function(){
		for(var ix=0;ix <itemHolder.boxes.length;ix++){
			itemHolder.boxes[ix].save();
		}
	},

	// retrieve from localstorage
	restoreElements:function(){
		for(var ix=0;ix <itemHolder.boxes.length;ix++){
			itemHolder.boxes[ix].restore();
		}
	},
//********************  exposed API *****************	
// -----------------------------------
// get a box by wrapper element
	getBoxByElement:function(elt){
	// assuming elt is wrapper
		for(var ix=0;ix < itemHolder.boxes.length;ix++){
			if(itemHolder.boxes[ix].getWrapperElement() == elt)
				return itemHolder.boxes[ix];
		}
		return null;
	},
// ------------------------------------
// get a box by id
	getBoxById:function(id){
		for(var ix=0;ix < itemHolder.boxes.length;ix++){
			if(itemHolder.boxes[ix].getId() == id)
				return itemHolder.boxes[ix];
		}
		return null;		
	},
// ------------------------------------
// get a box ix id
	getBoxIxById:function(id){
		for(var ix=0;ix < itemHolder.boxes.length;ix++){
			if(itemHolder.boxes[ix].getId() == id)
				return ix;
		}
		return -1;		
	},
//---------- general positioning, any element ------------
	getPosition:function (elt) {
		var xPosition = 0;
		var yPosition = 0;
	  
		while(elt) {
			xPosition += (elt.offsetLeft - elt.scrollLeft + elt.clientLeft);
			yPosition += (elt.offsetTop - elt.scrollTop + elt.clientTop);
			elt = elt.offsetParent; // relative or absolute
		}
		return { left: xPosition, top: yPosition };
	},
	setPosition:function(elt,L,T){
		if(elt.hasAttribute("style")){
			elt.style.left=L+"px";
			elt.style.top=T+"px";
		}
		else{
			elt.setAttribute('style','left:'+L+'px;top:'+T+'px');
		}
	}

}

